Index: /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/CompRegistryProxyAction.java
===================================================================
--- /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/CompRegistryProxyAction.java	(revision 910)
+++ /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/CompRegistryProxyAction.java	(revision 911)
@@ -136,7 +136,8 @@
 					Admin.notifyUser("CCCRPA." + getTargetRequest());
 					Admin.notifyUser("CCCRPA." + getFullFormat());
-					MDTransformer.getMDTransformer().setSrcFile(getTargetRequest());
-					MDTransformer.getMDTransformer().setParams(createTransformerParams());
-					_sourceStream = MDTransformer.getMDTransformer().transformXML(__sourceStream);//, getFullFormat(),null,null,null,null,null,null);
+					MDTransformer transformer = new MDTransformer();
+					transformer.setSrcFile(getTargetRequest());
+					transformer.setParams(createTransformerParams());
+					_sourceStream = transformer.transformXML(__sourceStream);//, getFullFormat(),null,null,null,null,null,null);
 					Admin.notifyUser("CRPA.- elements");
 					setActionkey("elements");
@@ -163,7 +164,8 @@
 			}else {
 				// set URL as srcFile (for MDTransformer to pass to xsl-scripts) 
-				MDTransformer.getMDTransformer().setSrcFile(getTargetRequest());
-				MDTransformer.getMDTransformer().setParams(MDTransformer.createParamsMap(getFullFormat()));
-				_resultStream = MDTransformer.getMDTransformer().transformXML(_sourceStream);//, getFullFormat());
+				MDTransformer transformer = new MDTransformer();
+				transformer.setSrcFile(getTargetRequest());
+				transformer.setParams(MDTransformer.createParamsMap(getFullFormat()));
+				_resultStream = transformer.transformXML(_sourceStream);//, getFullFormat());
 					
 			}
Index: /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/GenericProxyAction.java
===================================================================
--- /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/GenericProxyAction.java	(revision 910)
+++ /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/GenericProxyAction.java	(revision 911)
@@ -384,7 +384,8 @@
 		InputStream in  = new BufferedInputStream( new FileInputStream(path));;
 		
-		MDTransformer.getMDTransformer().setSrcFile(file.toURL());
-		MDTransformer.getMDTransformer().setParams(MDTransformer.createParamsMap("xml2json"));
-		InputStream jsonstream = MDTransformer.getMDTransformer().transformXML(in);
+		MDTransformer transformer = new MDTransformer();
+		transformer.setSrcFile(file.toURL());
+		transformer.setParams(MDTransformer.createParamsMap("xml2json"));
+		InputStream jsonstream = transformer.transformXML(in);
 		
 		JSONObject json = JSONObject.fromObject(convertStreamToString(jsonstream));
@@ -526,10 +527,11 @@
 			resultStream = sourceStream;	
 		}else {
-			// set URL as srcFile (for MDTransformer to pass to xsl-scripts) 
-			MDTransformer.getMDTransformer().setSrcFile(getTargetRequest());
+			// set URL as srcFile (for MDTransformer to pass to xsl-scripts)
+			MDTransformer transformer = new MDTransformer();
+			transformer.setSrcFile(getTargetRequest());
 			// getColumns
 			Admin.notifyUser("GPA.getRepository, before xsl:" + getRepository());
-			MDTransformer.getMDTransformer().setParams(createTransformerParams());
-			resultStream = MDTransformer.getMDTransformer().transformXML(sourceStream);//, getFullFormat(), getColumns(), getStartRecord(), getMaximumRecords(),getLang(),getQ(),String.valueOf(getRepository()));
+			transformer.setParams(createTransformerParams());
+			resultStream = transformer.transformXML(sourceStream);//, getFullFormat(), getColumns(), getStartRecord(), getMaximumRecords(),getLang(),getQ(),String.valueOf(getRepository()));
 		}
 			
Index: /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/GenericWorkspaceAction.java
===================================================================
--- /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/GenericWorkspaceAction.java	(revision 910)
+++ /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/GenericWorkspaceAction.java	(revision 911)
@@ -179,8 +179,9 @@
 		}else { //JSON
 			// set srcFile (for MDTransformer to pass to xsl-scripts) 
-			MDTransformer.getMDTransformer().setSrcFile(getURL());
+			MDTransformer transformer = new MDTransformer();
+			transformer.setSrcFile(getURL());
 			//InputStream tmp_s =  MDTransformer.getMDTransformer().transformXML(sourceStream, "attr2elements");
-			MDTransformer.getMDTransformer().setParams(MDTransformer.createParamsMap(getFullFormat()));
-			InputStream s =  MDTransformer.getMDTransformer().transformXML(sourceStream);//, getFullFormat());
+			transformer.setParams(MDTransformer.createParamsMap(getFullFormat()));
+			InputStream s =  transformer.transformXML(sourceStream);//, getFullFormat());
 			resultStream = getPart(s);
 		}
Index: /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/MDTransformer.java
===================================================================
--- /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/MDTransformer.java	(revision 910)
+++ /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/MDTransformer.java	(revision 911)
@@ -53,5 +53,5 @@
 	private HashMap<String,String> params;
 		
-	private static MDTransformer singleton;
+	private MDTransformer singleton;
 	TransformerFactory tfactory ; 
 	
@@ -60,4 +60,5 @@
 	}
 	
+	/*
 	public static MDTransformer getMDTransformer () {
 		if (singleton == null) {
@@ -66,5 +67,5 @@
 		return singleton;
 	}
-	
+	*/
 	
 	public URL getSrcFile() {
Index: /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/TermsProxyAction.java
===================================================================
--- /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/TermsProxyAction.java	(revision 910)
+++ /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/TermsProxyAction.java	(revision 911)
@@ -131,6 +131,7 @@
 			InputStream resultStream=null;
 			try {
-				MDTransformer.getMDTransformer().setParams(createTransformerParams());
-				resultStream = MDTransformer.getMDTransformer().transformXML(stream_matrix_all);//, "terms2extract", getColumns(), getStartRecord(), getMaximumRecords(),getLang(),getQ(), getRepositoryPath());
+				MDTransformer transformer = new MDTransformer();
+				transformer.setParams(createTransformerParams());
+				resultStream = transformer.transformXML(stream_matrix_all);//, "terms2extract", getColumns(), getStartRecord(), getMaximumRecords(),getLang(),getQ(), getRepositoryPath());
 			} catch (InterruptedException e) {				
 				Admin.notifyUser("TPA.getSourceStream(): "+ e.getMessage());
Index: /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/WorkspaceAction.java
===================================================================
--- /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/WorkspaceAction.java	(revision 910)
+++ /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/action/WorkspaceAction.java	(revision 911)
@@ -272,7 +272,8 @@
 		}else { //JSON
 			// set srcFile (for MDTransformer to pass to xsl-scripts) 
-			MDTransformer.getMDTransformer().setSrcFile(getURL());
-			MDTransformer.getMDTransformer().setParams(MDTransformer.createParamsMap(getFullFormat()));
-			setResultStream(MDTransformer.getMDTransformer().transformXML(in));//, getFullFormat()));
+			MDTransformer transformer = new MDTransformer();
+			transformer.setSrcFile(getURL());
+			transformer.setParams(MDTransformer.createParamsMap(getFullFormat()));
+			setResultStream(transformer.transformXML(in));//, getFullFormat()));
 			//setSessionData(getResultStream());
 		}
Index: /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/model/Query.java
===================================================================
--- /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/model/Query.java	(revision 910)
+++ /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/model/Query.java	(revision 911)
@@ -393,6 +393,7 @@
 	 */
 	public String toXPath() {	
-		MDTransformer.getMDTransformer().setParams(MDTransformer.createParamsMap("XCQL2XPATH"));
-		return MDTransformer.getMDTransformer().transformXML(toXCQL());
+		MDTransformer transformer = new MDTransformer();
+		transformer.setParams(MDTransformer.createParamsMap("XCQL2XPATH"));
+		return transformer.transformXML(toXCQL());
 	}
 
Index: /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/model/Result.java
===================================================================
--- /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/model/Result.java	(revision 910)
+++ /MDService2/trunk/MDService2/src/eu/clarin/cmdi/mdservice/model/Result.java	(revision 911)
@@ -58,6 +58,7 @@
 			transformkey = parentQuery.getType() + "2" + format;
 			Admin.notifyUser("transformkey: " + transformkey );
-			MDTransformer.getMDTransformer().setParams(MDTransformer.createParamsMap(transformkey));
-			return MDTransformer.getMDTransformer().transformXML(rawresult);//, transformkey);
+			MDTransformer transformer = new MDTransformer();
+			transformer.setParams(MDTransformer.createParamsMap(transformkey));
+			return transformer.transformXML(rawresult);//, transformkey);
 		}	
 	}