Index: /metadata/trunk/toolkit/comp2schema-header.xsl
===================================================================
--- /metadata/trunk/toolkit/comp2schema-header.xsl	(revision 972)
+++ /metadata/trunk/toolkit/comp2schema-header.xsl	(revision 973)
@@ -8,5 +8,34 @@
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:xs="http://www.w3.org/2001/XMLSchema" version="2.0">
+    
+    
+    <xsl:template name="PrintHeaderType">
+        <xs:simpleType name="Resourcetype_simple">
+            <xs:restriction base="xs:string">    
+                <xs:enumeration value="Metadata">
+                    <xs:annotation>
+                        <xs:documentation>The ResourceProxy
+                            refers to another component
+                            metadata instance (e.g. for
+                            grouping metadata descriptions
+                            into
+                            collections)</xs:documentation>
+                    </xs:annotation>
+                </xs:enumeration>
+                <xs:enumeration value="Resource">
+                    <xs:annotation>
+                        <xs:documentation>The ResourceProxy
+                            refers to a file that is not a
+                            metadata instance (e.g. a text
+                            document)</xs:documentation>
+                    </xs:annotation>
+                </xs:enumeration>
+            </xs:restriction>    
+        </xs:simpleType>
+    </xsl:template>
+    
+    
     <xsl:template name="PrintHeader">
+    
         <xs:element name="Header">
             <xs:complexType>
@@ -19,4 +48,5 @@
             </xs:complexType>
         </xs:element>
+
         <xs:element name="Resources">
             <xs:complexType>
@@ -28,33 +58,21 @@
                                     <xs:complexType>
                                         <xs:sequence>
+
                                             <xs:element maxOccurs="1" minOccurs="1"
                                                 name="ResourceType">
-                                                <xs:simpleType>
-                                                  <xs:restriction base="xs:string">
-                                                  <xs:enumeration value="Metadata">
-                                                  <xs:annotation>
-                                                  <xs:documentation>The ResourceProxy
-                                                  refers to another component
-                                                  metadata instance (e.g. for
-                                                  grouping metadata descriptions
-                                                  into
-                                                  collections)</xs:documentation>
-                                                  </xs:annotation>
-                                                  </xs:enumeration>
-                                                  <xs:enumeration value="Resource">
-                                                  <xs:annotation>
-                                                  <xs:documentation>The ResourceProxy
-                                                  refers to a file that is not a
-                                                  metadata instance (e.g. a text
-                                                  document)</xs:documentation>
-                                                  </xs:annotation>
-                                                  </xs:enumeration>
-                                                  </xs:restriction>
-                                                </xs:simpleType>
+                                                <xs:complexType>                                                
+                                                    <xs:simpleContent>
+                                                        <xs:extension base="Resourcetype_simple">
+                                                            <xs:attribute name="mimetype" type="xs:string"/>
+                                                        </xs:extension>
+                                                    </xs:simpleContent>
+                                                </xs:complexType>
                                             </xs:element>
+        
                                             <xs:element maxOccurs="1" minOccurs="1"
                                                 name="ResourceRef" type="xs:anyURI"/>
                                         </xs:sequence>
                                         <xs:attribute name="id" type="xs:ID" use="required"/>
+                                    
                                     </xs:complexType>
                                 </xs:element>
Index: /metadata/trunk/toolkit/comp2schema.xsl
===================================================================
--- /metadata/trunk/toolkit/comp2schema.xsl	(revision 972)
+++ /metadata/trunk/toolkit/comp2schema.xsl	(revision 973)
@@ -56,4 +56,7 @@
             <!--  first create complex types for valueschemes (not inline) -->
             <xsl:call-template name="CreateComplexTypes"/>
+            
+            <!-- then create simple type for the ResourceProxy -->
+            <xsl:call-template name="PrintHeaderType"/>
 
             <xs:element name="CMD">
Index: /metadata/trunk/toolkit/xslt/comp2schema-v2/comp2schema-header.xsl
===================================================================
--- /metadata/trunk/toolkit/xslt/comp2schema-v2/comp2schema-header.xsl	(revision 972)
+++ /metadata/trunk/toolkit/xslt/comp2schema-v2/comp2schema-header.xsl	(revision 973)
@@ -8,4 +8,31 @@
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:xs="http://www.w3.org/2001/XMLSchema" version="2.0">
+
+    <xsl:template name="PrintHeaderType">
+        <xs:simpleType name="Resourcetype_simple">
+            <xs:restriction base="xs:string">    
+                <xs:enumeration value="Metadata">
+                    <xs:annotation>
+                        <xs:documentation>The ResourceProxy
+                            refers to another component
+                            metadata instance (e.g. for
+                            grouping metadata descriptions
+                            into
+                            collections)</xs:documentation>
+                    </xs:annotation>
+                </xs:enumeration>
+                <xs:enumeration value="Resource">
+                    <xs:annotation>
+                        <xs:documentation>The ResourceProxy
+                            refers to a file that is not a
+                            metadata instance (e.g. a text
+                            document)</xs:documentation>
+                    </xs:annotation>
+                </xs:enumeration>
+            </xs:restriction>    
+        </xs:simpleType>
+    </xsl:template>
+
+
     <xsl:template name="PrintHeader">
         
@@ -31,26 +58,11 @@
                                             <xs:element maxOccurs="1" minOccurs="1"
                                                 name="ResourceType">
-                                                <xs:simpleType>
-                                                  <xs:restriction base="xs:string">
-                                                  <xs:enumeration value="Metadata">
-                                                  <xs:annotation>
-                                                  <xs:documentation>The ResourceProxy
-                                                  refers to another component
-                                                  metadata instance (e.g. for
-                                                  grouping metadata descriptions
-                                                  into
-                                                  collections)</xs:documentation>
-                                                  </xs:annotation>
-                                                  </xs:enumeration>
-                                                  <xs:enumeration value="Resource">
-                                                  <xs:annotation>
-                                                  <xs:documentation>The ResourceProxy
-                                                  refers to a file that is not a
-                                                  metadata instance (e.g. a text
-                                                  document)</xs:documentation>
-                                                  </xs:annotation>
-                                                  </xs:enumeration>
-                                                  </xs:restriction>
-                                                </xs:simpleType>
+                                                <xs:complexType>                                                
+                                                    <xs:simpleContent>
+                                                        <xs:extension base="Resourcetype_simple">
+                                                            <xs:attribute name="mimetype" type="xs:string"/>
+                                                        </xs:extension>
+                                                    </xs:simpleContent>
+                                                </xs:complexType>
                                             </xs:element>
                                             <xs:element maxOccurs="1" minOccurs="1"
Index: /metadata/trunk/toolkit/xslt/comp2schema-v2/comp2schema.xsl
===================================================================
--- /metadata/trunk/toolkit/xslt/comp2schema-v2/comp2schema.xsl	(revision 972)
+++ /metadata/trunk/toolkit/xslt/comp2schema-v2/comp2schema.xsl	(revision 973)
@@ -65,5 +65,6 @@
             <xsl:call-template name="CreateComplexTypes"/>
 
-
+            <!-- then create simple type for the ResourceProxy -->
+            <xsl:call-template name="PrintHeaderType"/>
 
 