Index: /vlo/trunk/vlo_webapp/src/main/java/eu/clarin/cmdi/vlo/importer/CMDIData.java
===================================================================
--- /vlo/trunk/vlo_webapp/src/main/java/eu/clarin/cmdi/vlo/importer/CMDIData.java	(revision 988)
+++ /vlo/trunk/vlo_webapp/src/main/java/eu/clarin/cmdi/vlo/importer/CMDIData.java	(revision 989)
@@ -17,10 +17,14 @@
     }
 
-    public void addDocField(String name, String value) {
+    public void addDocField(String name, String value, boolean caseSensitive) {
         if (doc == null) {
             doc = new SolrInputDocument();
         }
         if (value != null && !value.isEmpty()) {
-            doc.addField(name, value);
+            if (caseSensitive) {
+                doc.addField(name, value.toLowerCase());
+            } else {
+                doc.addField(name, value);
+            }
         }
     }
@@ -43,4 +47,3 @@
         return id;
     }
-
 }
Index: /vlo/trunk/vlo_webapp/src/main/java/eu/clarin/cmdi/vlo/importer/CMDIDigester.java
===================================================================
--- /vlo/trunk/vlo_webapp/src/main/java/eu/clarin/cmdi/vlo/importer/CMDIDigester.java	(revision 988)
+++ /vlo/trunk/vlo_webapp/src/main/java/eu/clarin/cmdi/vlo/importer/CMDIDigester.java	(revision 989)
@@ -78,15 +78,15 @@
         List<FacetConfiguration> facetList = facetMapping.getFacets();
         for (FacetConfiguration facetConfiguration : facetList) {
-            matchDocumentField(result, facetConfiguration.getPattern(), facetConfiguration.getName(), doc, xpath);
+            matchDocumentField(result, facetConfiguration, doc, xpath);
         }
         return result;
     }
 
-    private void matchDocumentField(CMDIData result, String pattern, String fieldName, Document doc, XPath xpath)
+    private void matchDocumentField(CMDIData result, FacetConfiguration facetConfig, Document doc, XPath xpath)
             throws XPathExpressionException {
-        NodeList nodes = (NodeList) xpath.evaluate(pattern, doc, XPathConstants.NODESET);
+        NodeList nodes = (NodeList) xpath.evaluate(facetConfig.getPattern(), doc, XPathConstants.NODESET);
         if (nodes != null) {
             for (int i = 0; i < nodes.getLength(); i++) {
-                result.addDocField(fieldName, nodes.item(i).getNodeValue());
+                result.addDocField(facetConfig.getName(), nodes.item(i).getNodeValue(), facetConfig.isCaseSensitive());
             }
         } // else do nothing it is perfectly acceptable that not all data is in a cmdi file so not everything will be matched. E.G xpath expression evaluation CMDI session files will never match on CMD corpus files.
Index: /vlo/trunk/vlo_webapp/src/test/java/eu/clarin/cmdi/vlo/importer/CMDIDigesterTest.java
===================================================================
--- /vlo/trunk/vlo_webapp/src/test/java/eu/clarin/cmdi/vlo/importer/CMDIDigesterTest.java	(revision 988)
+++ /vlo/trunk/vlo_webapp/src/test/java/eu/clarin/cmdi/vlo/importer/CMDIDigesterTest.java	(revision 989)
@@ -375,5 +375,5 @@
         assertEquals("Netherlands", doc.getFieldValue("country"));
         assertEquals("Max Planck Institute for Psycholinguistics", doc.getFieldValue("organisation"));
-        assertEquals("Unspecified", doc.getFieldValue("genre"));
+        assertEquals("unspecified", doc.getFieldValue("genre"));
         assertEquals(
                 "This  recording was made to generate a freely available test resource including speech and gestures. The annotations were created by Peter and Kita who is gesture researcher at the MPI for Psycholinguistics.",
@@ -466,5 +466,5 @@
         assertEquals("Europe", doc.getFieldValue("continent"));
         assertEquals("Netherlands", doc.getFieldValue("country"));
-        assertEquals("Unspecified", doc.getFieldValue("genre"));
+        assertEquals("unspecified", doc.getFieldValue("genre"));
         assertEquals("Test.", doc.getFieldValue("description"));
         assertEquals("Should be null not empty string", null, doc.getFieldValue("organisation"));
@@ -533,5 +533,5 @@
         assertEquals(null, doc.getFieldValue("country"));
         assertEquals(null, doc.getFieldValue("organisation"));
-        assertEquals("Transcription", doc.getFieldValue("genre"));
+        assertEquals("transcription", doc.getFieldValue("genre"));
       //  assertEquals("Kuna", doc.getFieldValue("subject"));
         assertEquals(2, doc.getFieldValues("description").size());