Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/Application.properties
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/Application.properties	(revision 1018)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/Application.properties	(revision 1019)
@@ -1,2 +1,18 @@
+State.PUBLIC: public
+State.PUBLIC_PENDING: publishing
+State.PRIVATE: private
+State.DELETED: deleted
+State.DEAD: dead
+Type.EXTENSIONAL: extensional
+Type.INTENSIONAL: intensional
+Purpose.RESEARCH: research
+Purpose.REFERENCE: reference
+Purpose.SAMPLE: sample
+Purpose.FUTURE_USE: future-use
+Reproducibility.INTENDED: intended
+Reproducibility.FLUCTUATING: fluctuating
+Reproducibility.UNTENDED: untended
+Type.METADATA: Metadata
+Type.RESOURCE: Resource
 collections.publishconfirm: Do you really want to publish "${name}"?\nThe \
   virtual collection will then be publicly available and you will not be able \
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/VirtualCollectionDetailsPage.html
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/VirtualCollectionDetailsPage.html	(revision 1018)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/VirtualCollectionDetailsPage.html	(revision 1019)
@@ -8,18 +8,18 @@
 <wicket:extend>
   <div wicket:id="generalBorder">
-    <div>
+    <div class="property">
       <label>Name</label>
       <div wicket:id="name"></div>
     </div>
-    <div>
+    <div class="property">
        <label>Type</label>
        <div wicket:id="type"></div>
     </div>
-    <div>
+    <div class="property">
       <label>Creation Date</label>
       <div wicket:id="creationDate"></div>
     </div>
     <wicket:enclosure child="description">
-      <div>
+      <div class="property">
         <label>Description</label>
         <div wicket:id="description"></div>
@@ -27,5 +27,5 @@
     </wicket:enclosure>
     <wicket:enclosure child="purpose">
-      <div>
+      <div class="property">
         <label>Purpose</label>
         <div wicket:id="purpose"></div>
@@ -33,5 +33,5 @@
     </wicket:enclosure>
     <wicket:enclosure child="reproducibility">
-      <div>
+      <div class="property">
         <label>Reproducibility</label>
         <div wicket:id="reproducibility"></div>
@@ -39,5 +39,5 @@
     </wicket:enclosure>
     <wicket:enclosure child="reproducibilityNotice">
-      <div>
+      <div class="property">
         <label>Reproducibility Notice</label>
         <div wicket:id="reproducibilityNotice"></div>
@@ -45,8 +45,8 @@
     </wicket:enclosure>
     <wicket:enclosure child="keywords">
-      <div>
+      <div class="property">
         <label>Keywords</label>
         <div>
-          <ul><li wicket:id="keywords"><span wicket:id="keyword"></span></li></ul>
+          <ul class="keywords"><li wicket:id="keywords"><span wicket:id="keyword"></span></li></ul>
         </div>
       </div>
@@ -55,12 +55,12 @@
 
   <div wicket:id="creatorsBorder">
-    <ul>
+    <ul class="creators">
       <li wicket:id="creators">
-        <div>
+        <div class="property">
           <label>Person</label>
           <div wicket:id="person"></div>
         </div>
         <wicket:enclosure child="address">
-          <div>
+          <div class="property">
             <label>Address</label>
             <div wicket:id="address"></div>
@@ -68,5 +68,5 @@
         </wicket:enclosure>
         <wicket:enclosure child="email">
-          <div>
+          <div class="property">
             <label>Email</label>
             <div wicket:id="email"></div>
@@ -74,5 +74,5 @@
         </wicket:enclosure>
         <wicket:enclosure child="organisation">
-          <div>
+          <div class="property">
             <label>Organisation</label>
             <div wicket:id="organisation"></div>
@@ -80,5 +80,5 @@
         </wicket:enclosure>
         <wicket:enclosure child="telephone">
-          <div>
+          <div class="property">
             <label>Telephone</label>
             <div wicket:id="telephone"></div>
@@ -86,5 +86,5 @@
         </wicket:enclosure>
         <wicket:enclosure child="website">
-          <div>
+          <div class="property">
             <label>Website</label>
             <div><a wicket:id="website"></a></div>
@@ -92,5 +92,5 @@
         </wicket:enclosure>
         <wicket:enclosure child="role">
-          <div>
+          <div class="property">
             <label>Role</label>
             <div wicket:id="role"></div>
@@ -106,10 +106,10 @@
 
   <div wicket:id="generatedByBorder">
-    <div>
+    <div class="property">
       <label>Description</label>
       <div wicket:id="generatedBy.description"></div>
     </div>
     <wicket:enclosure child="generatedBy.uri">
-      <div>
+      <div class="property">
         <label>URI</label>
         <div wicket:id="generatedBy.uri"></div>
@@ -117,5 +117,5 @@
     </wicket:enclosure>
     <wicket:enclosure child="generatedBy.query.profile">
-      <div>
+      <div class="property">
         <label>Profile</label>
         <div wicket:id="generatedBy.query.profile"></div>
@@ -123,5 +123,5 @@
     </wicket:enclosure>
     <wicket:enclosure child="generatedBy.query.value">
-      <div>
+      <div class="property">
         <label>Value</label>
         <div wicket:id="generatedBy.query.value"></div>
@@ -130,5 +130,7 @@
   </div>
 
-  <a wicket:id="back" href="#">[return to previous page]</a>
+  <div class="collectionDetails buttons">
+    <a wicket:id="back" href="#">[return to previous page]</a>
+  </div>
 </wicket:extend>
 </body>
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/VirtualCollectionDetailsPage.java
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/VirtualCollectionDetailsPage.java	(revision 1018)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/VirtualCollectionDetailsPage.java	(revision 1019)
@@ -1,18 +1,23 @@
 package eu.clarin.cmdi.virtualcollectionregistry.gui.pages;
 
-import java.util.ArrayList;
+import java.sql.Date;
 import java.util.Collection;
 import java.util.Iterator;
 import java.util.LinkedList;
 import java.util.List;
-
+import java.util.Locale;
+
+import org.apache.commons.lang.time.FastDateFormat;
+import org.apache.wicket.Application;
 import org.apache.wicket.Component;
 import org.apache.wicket.Page;
 import org.apache.wicket.behavior.AbstractBehavior;
 import org.apache.wicket.extensions.ajax.markup.html.repeater.data.table.AjaxFallbackDefaultDataTable;
+import org.apache.wicket.extensions.markup.html.repeater.data.grid.ICellPopulator;
 import org.apache.wicket.extensions.markup.html.repeater.data.table.DataTable;
 import org.apache.wicket.extensions.markup.html.repeater.data.table.IColumn;
 import org.apache.wicket.extensions.markup.html.repeater.data.table.PropertyColumn;
 import org.apache.wicket.extensions.markup.html.repeater.util.SortableDataProvider;
+import org.apache.wicket.markup.ComponentTag;
 import org.apache.wicket.markup.html.basic.Label;
 import org.apache.wicket.markup.html.basic.MultiLineLabel;
@@ -23,8 +28,12 @@
 import org.apache.wicket.markup.html.list.ListItem;
 import org.apache.wicket.markup.html.list.ListView;
+import org.apache.wicket.markup.html.list.OddEvenListItem;
+import org.apache.wicket.markup.repeater.Item;
 import org.apache.wicket.model.ComponentPropertyModel;
 import org.apache.wicket.model.CompoundPropertyModel;
 import org.apache.wicket.model.IModel;
 import org.apache.wicket.model.Model;
+import org.apache.wicket.util.convert.IConverter;
+import org.apache.wicket.util.string.Strings;
 
 import eu.clarin.cmdi.virtualcollectionregistry.gui.border.AjaxToggleBorder;
@@ -37,5 +46,34 @@
 @SuppressWarnings("serial")
 public class VirtualCollectionDetailsPage extends BasePage {
-    private static final String CSS_CLASS = "collectionsDetails";
+    private static final IConverter convEnum = new IConverter() {
+        @Override
+        public String convertToString(Object o, Locale locale) {
+            final Enum<?> enumObj = (Enum<?>) o;
+            final String key =
+                enumObj.getDeclaringClass().getSimpleName() + "." +
+                enumObj.name();
+            final String value = Application.get().getResourceSettings()
+                    .getLocalizer().getString(key, null);
+            return Strings.escapeMarkup(value).toString();
+        }
+
+        @Override
+        public Object convertToObject(String s, Locale locale) {
+            return null;
+        }
+    };
+    private static final IConverter convDate = new IConverter() {
+        @Override
+        public String convertToString(Object o, Locale locale) {
+            return FastDateFormat.getInstance("yyyy-MM-dd")
+                .format((Date) o);
+        }
+
+        @Override
+        public Object convertToObject(String s, Locale locale) {
+            return null;
+        }
+    };
+    private static final String CSS_CLASS = "collectionDetails";
 
     /*
@@ -74,10 +112,30 @@
             components.clear();
         }
-    }
+    } // class VirtualCollectionDetailsPage.HideIfEmptyBehavior
+    
+    private static class CustomLabel extends Label {
+
+        public CustomLabel(String id) {
+            super(id);
+        }
+
+        @Override
+        public IConverter getConverter(Class<?> type) {
+            if (VirtualCollection.Type.class.isAssignableFrom(type) ||
+                VirtualCollection.Purpose.class.isAssignableFrom(type) ||
+                VirtualCollection.Reproducibility.class.isAssignableFrom(type)) {
+                return convEnum;
+            }
+            if (Date.class.isAssignableFrom(type)) {
+                return convDate;
+            }
+            return super.getConverter(type);
+        }
+    } // class VirtualCollectionDetailsPage.TypeLabel
 
     
     private final HideIfEmptyBehavior hideIfEmpty = new HideIfEmptyBehavior();
 
-
+    
     public VirtualCollectionDetailsPage(final IModel<VirtualCollection> model,
             final Page previousPage) {
@@ -98,9 +156,9 @@
         add(general);
         general.add(new Label("name"));
-        general.add(new Label("type"));
-        general.add(new Label("creationDate"));
+        general.add(new CustomLabel("type"));
+        general.add(new CustomLabel("creationDate"));
         general.add(new MultiLineLabel("description").add(hideIfEmpty));
-        general.add(new Label("purpose").add(hideIfEmpty));
-        general.add(new Label("reproducibility").add(hideIfEmpty));
+        general.add(new CustomLabel("purpose").add(hideIfEmpty));
+        general.add(new CustomLabel("reproducibility").add(hideIfEmpty));
         general.add(new Label("reproducibilityNotice").add(hideIfEmpty));
         final ListView<String> keywords = new ListView<String>("keywords") {
@@ -138,16 +196,42 @@
                 return new CompoundPropertyModel<Creator>(creators.get(index));
             }
+
+            @Override
+            protected ListItem<Creator> newItem(int index) {
+                final IModel<Creator> model =
+                    getListItemModel(getModel(), index);
+                return new OddEvenListItem<Creator>(index, model) {
+                    @Override
+                    protected void onComponentTag(ComponentTag tag) {
+                        super.onComponentTag(tag);
+                        if (getIndex() == 0) {
+                            tag.append("class", "first", " ");
+                        }
+                    }
+                };
+            }
         });
 
         final Border resources = new AjaxToggleBorder("resourcesBorder",
-                new Model<String>("Resources"), CSS_CLASS);
+                new Model<String>("Resources"), CSS_CLASS + " resources");
         add(resources);
         
         final VirtualCollection vc = model.getObject();
-        final List<IColumn<Resource>> cols = new ArrayList<IColumn<Resource>>();
-        
-        cols.add(new PropertyColumn<Resource>(new Model<String>("Type"), "type"));
-        cols.add(new PropertyColumn<Resource>(new Model<String>("Reference"), "ref"));
-
+        @SuppressWarnings("rawtypes")
+        final IColumn[] cols = new IColumn[2];
+        cols[0] = new PropertyColumn<Resource>(
+                new Model<String>("Type"), "type") {
+            @Override
+            public void populateItem(Item<ICellPopulator<Resource>> item,
+                    String componentId, IModel<Resource> model) {
+                final Resource.Type type = model.getObject().getType();
+                item.add(new Label(componentId,
+                        convEnum.convertToString(type, getLocale())));
+            }
+        };
+        cols[1] = new PropertyColumn<Resource>(
+                new Model<String>("Reference"), "ref");
+
+        @SuppressWarnings("unchecked")
         final DataTable<Resource> resourcesTable =
             new AjaxFallbackDefaultDataTable<Resource>("resourcesTable",
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/table/VirtualCollectionTable.properties
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/table/VirtualCollectionTable.properties	(revision 1018)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/table/VirtualCollectionTable.properties	(revision 1019)
@@ -4,11 +4,4 @@
 column.description: Description
 column.created: Created
-Type.EXTENSIONAL: extensional
-Type.INTENSIONAL: intensional
-State.PUBLIC: public
-State.PUBLIC_PENDING: publishing
-State.PRIVATE: private
-State.DELETED: deleted
-State.DEAD: dead
 Relation.LT: less-than
 Relation.LE: less-than or equals
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/wizard/CreateVirtualCollectionWizard.properties
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/wizard/CreateVirtualCollectionWizard.properties	(revision 1018)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/wizard/CreateVirtualCollectionWizard.properties	(revision 1019)
@@ -1,13 +1,2 @@
-Type.EXTENSIONAL: extensional
-Type.INTENSIONAL: intensional
-Purpose.RESEARCH: research
-Purpose.REFERENCE: reference
-Purpose.SAMPLE: sample
-Purpose.FUTURE_USE: future-use
-Reproducibility.INTENDED: intended
-Reproducibility.FLUCTUATING: fluctuating
-Reproducibility.UNTENDED: untended
-Type.METADATA: Metadata
-Type.RESOURCE: Resource
 keywords.deleteconfirm: Do you really want to delete "{0}"?
 creators.deleteconfirm: Do you really want to delete "${person}"?
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/webapp/css/vcr.css
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/webapp/css/vcr.css	(revision 1018)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/webapp/css/vcr.css	(revision 1019)
@@ -213,5 +213,6 @@
 }
 
-form.wizard fieldset, div.wizard div.fieldset {
+form.wizard fieldset,
+div.wizard div.fieldset {
   clear: both;
   font-size: 100%;
@@ -250,5 +251,6 @@
 */
 
-form.wizard div, div.editDialog div {
+form.wizard div,
+div.editDialog div {
   clear: left;
   display: block;
@@ -304,12 +306,10 @@
   margin: 0 0 5px 0;
   text-align: right;
-}
-
-div.optional label{
   font-weight: normal;
 }
 
-div.required label, label.required {
-  font-weight: bold;
+div.required label,
+label.required {
+  font-weight: bold !important;
 }
 
@@ -692,5 +692,5 @@
 table.collectionsTable.private th.name,
 table.collectionsTable.private td.name {
-    width: 736px;
+    width: 732px;
 }
 
@@ -731,5 +731,5 @@
 
 table.collectionsTable td.name div.actions {
-	margin: 4px 0;
+	margin: 4px 0 2px 0;
 }
 
@@ -864,2 +864,70 @@
     color: #AE0000;
 }
+
+
+div.collectionDetails div.property {
+  clear: both;
+  font-size: 100%;
+  border: none;
+  padding: 0 10px 0 10px;
+  margin: 0 0 4px 0;
+}
+
+div.collectionDetails div label {
+  display: block;
+  float: left;
+  width: 140px;
+  padding: 0px 2px;
+  margin: 0;
+  text-align: right;
+  font-weight: normal;
+}
+
+div.collectionDetails div label:after {
+	content: ':';
+}
+
+div.collectionDetails div div {
+    display: block;
+    clear: none;
+    padding: 0px 2px;
+    margin-left: 144px;
+}
+
+div.collectionDetails ul.keywords {
+    margin: 0 0 0 16px;
+    padding: 0;
+    list-style: square;
+}
+
+div.collectionDetails ul.creators {
+	margin: 0;
+	padding: 0;
+    list-style: none;
+}
+
+div.collectionDetails ul.creators li {
+	border-top: 1px dotted #000000;
+    margin-top: 4px;
+    padding-top: 4px;
+}
+
+div.collectionDetails ul.creators li.first {
+	border-top: none;
+	margin-top: 0;
+	padding-top: 0;
+}
+
+div.collectionDetails.resources {
+	padding: 0 !important;
+}
+
+div.collectionDetails.resources table {
+	width: 100%;
+}
+
+div.collectionDetails.buttons {
+	margin: 10px 0 10px 0;
+	text-align: center;
+}
+